#!/usr/bin/python
#-*- coding:Utf-8 -*-

#Special thanks to James Kassemi for the timed event class! That part of code is from here: code.activestate.com/recipes/496800-event-scheduling-threadingtimer/

import thread
import threading 
import time
from time import mktime
#import socket
#import sys
import sqlite3 as sql
import gconf
#import subprocess
import datetime
from datetime import date
from datetime import datetime
#import dbus
import os

#bus = dbus.SystemBus()
#iface = dbus.Interface(bus.get_object('com.nokia.icd2','/com/nokia/icd2'),'com.nokia.icd2')

def ConnectionStatus():
  #state = iface.state_req()
  cmd = "dbus-send --print-reply --system --dest=com.nokia.icd2 /com/nokia/icd2 com.nokia.icd2.state_req | sed -n '2p' | awk {'print $2'} | tr -d '\n'"
  temp = os.popen(cmd)
  state = temp.read()
  return state

Namedays = {
'0101':'Fruzsina',
'0102':'Ábel',
'0103':'Benjámin, Genovéva',
'0104':'Leóna, Titusz',
'0105':'Simon',
'0106':'Boldizsár',
'0107':'Attila, Ramóna',
'0108':'Gyöngyvér',
'0109':'Marcell',
'0110':'Melánia',
'0111':'Ágota',
'0112':'Ernő',
'0113':'Veronika',
'0114':'Bódog',
'0115':'Lóránd, Lóránt',
'0116':'Gusztáv',
'0117':'Antal, Antónia',
'0118':'Piroska',
'0119':'Márió, Sára',
'0120':'Fábián, Sebestyén',
'0121':'Ágnes',
'0122':'Artúr, Vince',
'0123':'Rajmund, Zelma',
'0124':'Timót',
'0125':'Pál',
'0126':'Paula, Vanda',
'0127':'Angelika',
'0128':'Karola, Károly',
'0129':'Adél',
'0130':'Martina',
'0131':'Gerda, Marcella',
'0201':'Ignác',
'0202':'Aida, Karolina',
'0203':'Balázs',
'0204':'Csenge, Ráhel',
'0205':'Ágota, Ingrid',
'0206':'Dóra, Dorottya',
'0207':'Rómeó, Tódor',
'0208':'Aranka',
'0209':'Abigél, Alex',
'0210':'Elvira',
'0211':'Bertold, Marietta',
'0212':'Lídia, Lívia',
'0213':'Ella, Linda',
'0214':'Bálint, Valentin',
'0215':'Georgina, Kolos',
'0216':'Julianna, Lilla',
'0217':'Donát',
'0218':'Bernadett',
'0219':'Zsuzsanna',
'0220':'Aladár, Álmos',
'0221':'Eleonóra',
'0222':'Gerzson',
'0223':'Alfréd',
'0224':'Mátyás',
'0225':'Géza',
'0226':'Edina',
'0227':'Ákos, Bátor',
'0228':'Elemér',
'0301':'Albin',
'0302':'Lujza',
'0303':'Kornélia',
'0304':'Kázmér',
'0305':'Adorján, Adrián',
'0306':'Inez, Leonóra',
'0307':'Tamás',
'0308':'Zoltán',
'0309':'Fanni, Franciska',
'0310':'Ildikó',
'0311':'Szilárd',
'0312':'Gergely',
'0313':'Ajtony, Krisztián',
'0314':'Matild',
'0315':'Kristóf',
'0316':'Henrietta',
'0317':'Gertrúd, Patrik',
'0318':'Ede, Sándor',
'0319':'Bánk, József',
'0320':'Klaudia',
'0321':'Benedek',
'0322':'Beáta, Izolda',
'0323':'Emőke',
'0324':'Gábor, Karina',
'0325':'Irén, Írisz',
'0326':'Emánuel',
'0327':'Hajnalka',
'0328':'Gedeon, Johanna',
'0329':'Auguszta',
'0330':'Zalán',
'0331':'Árpád',
'0401':'Hugó',
'0402':'Áron',
'0403':'Buda, Richárd',
'0404':'Izidor',
'0405':'Vince',
'0406':'Bíborka, Vilmos',
'0407':'Herman',
'0408':'Dénes',
'0409':'Erhard',
'0410':'Zsolt',
'0411':'Leó, Szaniszló',
'0412':'Gyula',
'0413':'Ida',
'0414':'Tibor',
'0415':'Anasztázia, Tas',
'0416':'Csongor',
'0417':'Rudolf',
'0418':'Andrea, Ilma',
'0419':'Emma',
'0420':'Tivadar',
'0421':'Konrád',
'0422':'Csilla, Noémi',
'0423':'Béla',
'0424':'György',
'0425':'Márk',
'0426':'Ervin',
'0427':'Zita',
'0428':'Valéria',
'0429':'Péter',
'0430':'Katalin, Kitti',
'0501':'Fülöp, Jakab',
'0502':'Zsigmond',
'0503':'Irma, Tímea',
'0504':'Flórián, Mónika',
'0505':'Adrián, Györgyi',
'0506':'Frida, Ivett',
'0507':'Gizella',
'0508':'Mihály',
'0509':'Gergely',
'0510':'Ármin, Pálma',
'0511':'Ferenc',
'0512':'Pongrác',
'0513':'Imola, Szervác',
'0514':'Bonifác',
'0515':'Szonja, Zsófia',
'0516':'Botond, Mózes',
'0517':'Paszkál',
'0518':'Alexandra, Erik',
'0519':'Ivó, Milán',
'0520':'Bernát, Felícia',
'0521':'Konstantin',
'0522':'Júlia, Rita',
'0523':'Dezső',
'0524':'Eliza, Eszter',
'0525':'Orbán',
'0526':'Evelin, Fülöp',
'0527':'Hella',
'0528':'Csanád, Emil',
'0529':'Magdolna',
'0530':'Janka, Zsanett',
'0531':'Angéla',
'0601':'Tünde',
'0602':'Anita, Kármen',
'0603':'Klotild',
'0604':'Bulcsú',
'0605':'Fatime',
'0606':'Cintia, Norbert',
'0607':'Róbert',
'0608':'Medárd',
'0609':'Félix',
'0610':'Gréta, Margit',
'0611':'Barnabás',
'0612':'Villő',
'0613':'Anett, Antal',
'0614':'Vazul',
'0615':'Jolán, Vid',
'0616':'Jusztin',
'0617':'Alida, Laura',
'0618':'Arnold, Levente',
'0619':'Gyárfás',
'0620':'Rafael',
'0621':'Alajos, Leila',
'0622':'Paulina',
'0623':'Zoltán',
'0624':'Iván',
'0625':'Vilmos',
'0626':'János, Pál',
'0627':'László',
'0628':'Irén, Levente',
'0629':'Péter, Pál',
'0630':'Pál',
'0701':'Annamária, Tihamér',
'0702':'Ottó',
'0703':'Kornél, Soma',
'0704':'Ulrik',
'0705':'Emese, Sarolta',
'0706':'Csaba',
'0707':'Apollónia',
'0708':'Ellák',
'0709':'Lukrécia',
'0710':'Amália',
'0711':'Lili, Nóra',
'0712':'Dalma, Izabella',
'0713':'Jenő',
'0714':'Örs, Stella',
'0715':'Henrik, Roland',
'0716':'Valter',
'0717':'Elek, Endre',
'0718':'Frigyes',
'0719':'Emília',
'0720':'Illés',
'0721':'Dániel, Daniella',
'0722':'Magdolna',
'0723':'Lenke',
'0724':'Kincső, Kinga',
'0725':'Jakab, Kristóf',
'0726':'Anikó, Anna',
'0727':'Liliána, Olga',
'0728':'Szabolcs',
'0729':'Flóra, Márta',
'0730':'Judit, Xénia',
'0731':'Oszkár',
'0801':'Boglárka',
'0802':'Lehel',
'0803':'Hermina',
'0804':'Dominika, Dominik, Domonkos',
'0805':'Krisztina',
'0806':'Berta, Bettina',
'0807':'Ibolya',
'0808':'László',
'0809':'Emőd',
'0810':'Lőrinc',
'0811':'Tiborc, Zsuzsanna',
'0812':'Klára',
'0813':'Ipoly',
'0814':'Marcell',
'0815':'Mária',
'0816':'Ábrahám',
'0817':'Jácint',
'0818':'Ilona',
'0819':'Huba',
'0820':'István',
'0821':'Hajna, Sámuel',
'0822':'Menyhért, Mirjam',
'0823':'Bence',
'0824':'Bertalan',
'0825':'Lajos, Patrícia',
'0826':'Izsó',
'0827':'Gáspár',
'0828':'Ágoston',
'0829':'Beatrix, Erna',
'0830':'Rózsa',
'0831':'Bella, Erika',
'0901':'Egon, Egyed',
'0902':'Dorina, Rebeka',
'0903':'Hilda',
'0904':'Rozália',
'0905':'Lőrinc, Viktor',
'0906':'Zakariás',
'0907':'Regina',
'0908':'Adrienn, Mária',
'0909':'Ádám',
'0910':'Hunor, Nikolett',
'0911':'Teodóra',
'0912':'Mária',
'0913':'Kornél',
'0914':'Roxána, Szeréna',
'0915':'Enikő, Melitta',
'0916':'Edit',
'0917':'Zsófia',
'0918':'Diána',
'0919':'Vilhelmina',
'0920':'Friderika',
'0921':'Máté, Mirella',
'0922':'Móric',
'0923':'Tekla',
'0924':'Gellért, Mercédesz',
'0925':'Eufrozina, Kende',
'0926':'Jusztina, Pál',
'0927':'Adalbert',
'0928':'Vencel',
'0929':'Mihály',
'0930':'Jeromos',
'1001':'Malvin',
'1002':'Petra',
'1003':'Helga',
'1004':'Ferenc',
'1005':'Aurél',
'1006':'Brúnó, Renáta',
'1007':'Amália',
'1008':'Koppány',
'1009':'Dénes',
'1010':'Gedeon',
'1011':'Brigitta',
'1012':'Miksa',
'1013':'Ede, Kálmán',
'1014':'Helén',
'1015':'Teréz',
'1016':'Gál',
'1017':'Hedvig',
'1018':'Lukács',
'1019':'Nándor',
'1020':'Vendel',
'1021':'Orsolya',
'1022':'Előd',
'1023':'Gyöngyi',
'1024':'Salamon',
'1025':'Bianka, Blanka',
'1026':'Dömötör',
'1027':'Szabina',
'1028':'Simon, Szimonetta',
'1029':'Nárcisz',
'1030':'Alfonz',
'1031':'Farkas',
'1101':'Marianna',
'1102':'Achilles',
'1103':'Győző',
'1104':'Károly',
'1105':'Imre',
'1106':'Lénárd',
'1107':'Rezső',
'1108':'Zsombor',
'1109':'Tivadar',
'1110':'Réka',
'1111':'Márton',
'1112':'Jónás, Renátó',
'1113':'Szilvia',
'1114':'Aliz',
'1115':'Albert, Lipót',
'1116':'Ödön',
'1117':'Gergely, Hortenzia',
'1118':'Jenő',
'1119':'Erzsébet, Elizabet',
'1120':'Jolán',
'1121':'Olivér',
'1122':'Cecília',
'1123':'Kelemen, Klementina',
'1124':'Emma',
'1125':'Katalin',
'1126':'Virág',
'1127':'Virgil',
'1128':'Stefánia',
'1129':'Taksony',
'1130':'Andor, András',
'1201':'Elza',
'1202':'Melinda, Vivien',
'1203':'Ferenc, Olívia',
'1204':'Barbara, Borbála',
'1205':'Vilma',
'1206':'Miklós',
'1207':'Ambrus',
'1208':'Mária',
'1209':'Natália',
'1210':'Judit',
'1211':'Árpád',
'1212':'Gabriella',
'1213':'Luca, Otília',
'1214':'Szilárda',
'1215':'Valér',
'1216':'Aletta, Etelka',
'1217':'Lázár, Olimpia',
'1218':'Auguszta',
'1219':'Viola',
'1220':'Teofil',
'1221':'Tamás',
'1222':'Zénó',
'1223':'Viktória',
'1224':'Ádám, Éva',
'1225':'Éugénia',
'1226':'István',
'1227':'János',
'1228':'Kamilla',
'1229':'Tamara, Tamás',
'1230':'Dávid',
'1231':'Szilveszter'
}

class Operation(threading._Timer):
    def __init__(self, *args, **kwargs):
        threading._Timer.__init__(self, *args, **kwargs)
        self.setDaemon(True)

    def run(self):
        while True:
            self.finished.clear()
            self.finished.wait(self.interval)
            if not self.finished.isSet():
                self.function(*self.args, **self.kwargs)
            else:
                return
            self.finished.set()

class Manager(object):

    ops = []

    def add_operation(self, operation, interval, args=[], kwargs={}):
        op = Operation(interval, operation, args, kwargs)
        self.ops.append(op)
        thread.start_new_thread(op.run, ())

    def stop(self, operation):
        for op in self.ops:
          if operation == op:
            op.cancel()
        #self._event.set()

###################################################################

client = gconf.client_get_default()
client.add_dir("/apps/connui-cellular", gconf.CLIENT_PRELOAD_NONE)
database = sql.connect("/home/user/.calendar/calendardb", check_same_thread = False)
task = database.cursor()

def CheckingEvent():
  today = date(int(time.strftime("%Y")),int(time.strftime("%m")),int(time.strftime("%d")))
  today_unix = mktime(today.timetuple())
  tomorrow_unix = today_unix+86400
  task.execute("select Summary from Components where DateStart >= '"+str(int(today_unix))+"' and DateStart < '"+str(int(tomorrow_unix)-1)+"';")
  row = task.fetchall()
  event = str(len(row))
  return  event

def CheckingBirthday():
  task.execute("select DateStart,Summary from Components where ComponentType='4' and AllDay='1' and Flags='3';")
  celebs = []
  while True:
    row = task.fetchone()
    if row == None:
      break
    else:
      if datetime.fromtimestamp(int(row[0])).strftime("%m/%d") == time.strftime("%m/%d"):
        celebs.append(row[1])
  return str(len(celebs))

def CheckingNameday():
  now = datetime.now()
  if now.strftime('%Y') == 2016 or 2020:
    Namedays['0224'] = 'Szökőnap'
    Namedays['0225'] = 'Mátyás'
    Namedays['0226'] = 'Géza'
    Namedays['0227'] = 'Edina'
    Namedays['0228'] = 'Ákos, Bátor'
    Namedays['0229'] = 'Elemér'

  name = Namedays[now.strftime('%m%d')]
  return name

def Date():
  now = datetime.now()
  current_date = now.strftime('%H:%M | %a %d %b %Y')
  return current_date

###Special thanks to the thread pause using set() and clear() events for Rich, found on stackoverflow.com/questions/3262346/pausing-a-thread-using-threading-class###

def Refreshing(e):
  while True:
    e.wait()
    cmd = "sudo /opt/onr/GetWeatherInfo"
    os.system(cmd)
    #subprocess.call(cmd)
    cmd = "sudo /opt/onr/GetMoonInfo"
    os.system(cmd)
    #subprocess.call(cmd)
    time.sleep(800)
    e.clear()

e = threading.Event()
t = threading.Thread(target = Refreshing, args=(e, ))

def CheckingWirelessStatus():
  #Trying to make socket connection
  ##try:
    #s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
  ##except socket.error:
    ##print "%s" %(socket.error)
  #port = 80
  #Trying to resolve the host (i.e. connect to the internet)
  ##try:
    ##host = 'rss.accuweather.com' #define host (i.e. website)
    ##ip = socket.gethostbyname(host) #getting IP address here
    #print ip
    ##status = 1
    #s.connect((ip, port))
    #s.close()
  ##except socket.gaierror:
    ##status = 0
    #print "CouldNotResolveHost..."
    ##pass
    #sys.exit()
  if ConnectionStatus() == "1":
    if t.isAlive() != False:
      e.set()
    else:
      t.setDaemon(True)
      t.start()
  elif ConnectionStatus() == "0":
    if t.isAlive() != False:
      e.clear()
  f = open("/opt/onr/weatherdata", 'r')
  l = f.readlines()
  if len(l) == 8:
    weather_now = l[0][0:len(l[0])-2]
    weather_today = l[3][0:len(l[3])-2]
    weather_tomorrow = l[6][0:len(l[6])-2]
    f = open("/opt/onr/mooninfo", 'r')
    l = f.readlines()
    if len(l) == 9:
      if "Waning" in l[3]:
        moon = l[0][0:len(l[0])-1]+" -"
      elif "Third" in l[3]:
        moon = l[0][0:len(l[0])-1]+" -"
      elif "Waxing" in l[3]:
        moon = l[0][0:len(l[0])-1]+" +"
      elif "First" in l[3]:
        moon = l[0][0:len(l[0])-1]+" +"
      elif "Full" in l[3]:
        moon = l[0][0:len(l[0])-1]
      elif "New" in l[3]:
        moon = l[0][0:len(l[0])-1]
    elif len(l) != 9:
      moon = "N.A."
    weather_data = weather_now+" | "+moon+"\n"+weather_today+"\n"+weather_tomorrow
  elif len(l) != 8:
    weather_data = "N.A."+"\n"*3
  #return {'weather_data':weather_data, 'status':status
  return weather_data

def Battery():
  cmd = """hal-device bme | grep percentage | awk {'print $3"%"'} | tr -d '\n'"""
  temp = os.popen(cmd)
  batt = temp.read()
  return batt

def PrintData(current_date,name,birthday,event,batt,weather_data):
  client.set_string("/apps/connui-cellular/operator_name_online",current_date+"\n"+name+" | "+birthday+" | "+event+" | "+batt+"\n"+weather_data)

def GetData():
  PrintData(Date(),CheckingNameday(),CheckingBirthday(),CheckingEvent(),Battery(),CheckingWirelessStatus())

def MemoryCheck():
  pid = "pidof python /opt/onr/ONR.py | awk {'print $1'} | tr -d '\n'"
  temp = os.popen(pid)
  PID = temp.read()
  mem = "top -n 1 | grep "+PID+" | awk {'print $6'} | tr -d '\n'"
  temp = os.popen(mem)
  MEM = temp.read()
  if MEM >= "3.0":
    cmd = 'sudo /etc/init.d/onr restart'
    os.system(cmd)

if __name__ == '__main__':

  timer = Manager()
  timer.add_operation(GetData, 2)
  timer2 = Manager()
  timer2.add_operation(MemoryCheck, 60)


  while True:
      time.sleep(.1)
